<?
/*
Atom PhotoBlog (about.php) - PHP5 based photo-blogger
Copyright (C) 2007 by Sascha Tayefeh

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

if(isset($_GET['do'])) header('Location: ./atomPhotoBlog.php?do='.$_GET['do']);
require_once './apbData/vars.php';
require_once './apbClasses/AtomPhotoBlog.class.php';
$blog = new AtomPhotoBlog($apbPara); // There MUST NOT be any html-code before this line!!!
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<?  $blog->printHeaderElements(); ?>
	 <meta name="keywords" content="PhotoBlog, Atom PhotoBlog, Script, PHP, PHP5,
	 PhotoBlogger, Ilenvo, Software, Demo, Demonstration, Description, About, Atom, RSS, Feed, RSS2.0, Atom1.0" />

    <meta name="description" content="Atom PhotoBlog - The object-oriented, 
	 very fast PhotoBlogger Script. Demonstration Page" />
</head>
<body>
	<div id="workbench">
	    <div id="apbContainerUtils" class="apb container utils">

	    <?
	    $menu=array(
	       "About" => "./about.php",
	       "Atom 1.0" => "./blog/atom.xml",
	       "Rss 2.0" => "./blog/rss.xml"
	       );
	    $blog->printMenu($menu);
	     ?>
	     </div> <!-- end container UTILS> -->

	    <div id="apbAbout" class="apb form ">

	    <h1 class="apb form">Atom PhotoBlog</h1>
	    <p class="apb form">Copyright (c) 2007 by Sascha Tayefeh</p>
	    <h2 id="mainIndex" class="apb form">Content</h2>
	    <ol class="apb form">
	    <li class="apb form"><a href="#whatisthis">What is this?</a></li>
	    <li class="apb form"><a href="#features">Features</a></li>
	    <!--	    <li class="apb form"><a href="#screenshots">Screenshots</a></li>-->
	    <li class="apb form"><a href="#download">Download</a></li>
	    <li class="apb form"><a href="#install">Installation</a></li>
	    <li class="apb form"><a href="#license">License</a></li>
	    <li class="apb form"><a href="#developer">Developers</a></li>
	    </ol>
	    <h2 id="whatisthis" class="apb form">What is this?</h2>
	    <p class="apb form">
	    This is a demostration of the script <a  href="http://atomphotoblog.ilenvo.de">Atom PhotoBlog</a>.
	    A photo-blog is a blog with the intention to publish photos chronologically. This script
	    is dedicated to exactly this task - without any additional juggling. The word
	    &quot;Atom&quot; in the title indicates just this fact - we have created a kernel of such
	    a blog, there's nothing missing, but also, there's nothing nagging. Thus, these scripts
	    perform extremely good.</p>
	    <p class="apb form">The heart of this script is a set of PHP5-classes that provide everything you need in order to create your photoblog. Its user-interface makes the features highly customizable, while the object-oriented programming style makes it highly extensible. </p>

	    <p class="apb form"><a href="#mainIndex">Back To MainIndex</a></p>

	    <h2 id="features" class="apb form">Features</h2>
	    <ol class="apb form">
	    <li class="apb form">Small code makes the script work really FAST.</li>
	    <li class="apb form">Very easy and intuitive user- and admin-interface.</li>
	    <li class="apb from">Build-In resize of pictures exceeding maximum size.</li>
	    <li class="apb from">Automatic thumbnail creation.</li>
	    <li class="apb from">Moderated comments captcha protected.</li>
	    <li class="apb form">Atom 1.0 and RSS 2.0 feed.</li>
	    <li class="apb form">(Multiple) tagging.</li>
	    <li class="apb form">Completely CSS-based!</li>
	    <li class="apb form">W3C-Clean:
	    <a href="http://validator.w3.org/check?uri=http%3A%2F%2Fwww.ilenvo.de%2Fapb%2Fdemo%2Findex.php">XHTML</a>-,
	    <a href="http://jigsaw.w3.org/css-validator/validator?uri=http%3A%2F%2Fwww.ilenvo.de%2Fapb%2Fdemo%2FapbCss%2FatomPB.css">CSS</a>-,
	    <a href="http://validator.w3.org/feed/check.cgi?url=http://www.ilenvo.de/apb/demo/blog/atom.xml">ATOM 1.0</a>-,
	    and <a href="http://feedvalidator.org/check.cgi?url=http://www.ilenvo.de/apb/demo/blog/rss.xml">RSS 2.0</a> tested
	    at the <a href="http://www.w3.org/">World Wide Web (W3C) consortium</a>.</li>
	    <li class="apb form">Object-Oriented PHP5: The whole code is based on classes. Hence, the code is easily extensible.</li>
	    
	    </ol>

	    <p class="apb form"><a href="#mainIndex">Back To MainIndex</a></p>
	    <!--
	    	    <h2 id="screenshots" class="apb form">Screenshots</h2>
	    <p class="apb form">
	    [ Coming Soon ]
	    </p>
	    <p class="apb form"><a href="#mainIndex">Back To MainIndex</a></p>
	    -->


	    <h2 id="download" class="apb form">Download</h2>
	    <p class="apb form">
	    You can download a copy of these scripts either at 
	    <a href="http://atomPhotoBlog.ilenvo.de">http://atomPhotoBlog.ilenvo.de</a>, or at your favored PHP-Script Website ;-)
	    </p>
	    <p class="apb form"><a href="#mainIndex">Back To MainIndex</a></p>

	    <h2 id="install" class="apb form">Install</h2>

	    <ol class="apb form">
	    <li class="apb form">Upload all files into the same directory on your server.</li>
	    <li class="apb form"> Make sure that the directories &quot;apbData&quot; and &quot;blog&quot; are
   writeable. If you aren't sure, just set permissions to 777 (e.g. chmod 777 or give write-permission to all using
   your ftp-client).  </li>
	    <li class="apb form"> Using your favorite browser, go to the URL you uploaded this script and follow the instructions there.</li>
	    </ol>


	    <p class="apb form"><a href="#mainIndex">Back To MainIndex</a></p>



	    <h2 id="license" class="apb form">License</h2>
	    <p class="apb form">
	    This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
Please, read the complete <a href="http://www.gnu.org/copyleft/gpl.html">GNU PUBLIC LICENSE</a>.
	    </p>
	    <p class="apb form"><a href="#mainIndex">Back To MainIndex</a></p>

	    <h2 id="developer" class="apb form">Developers</h2>
	    <p class="apb form">
	    One of the main purposes of this script is to provide an extensible code. The structure of
	    these scripts makes it predestinated for you to implement these scripts into your homepage.
	    There are exhausting comments within the code, as well as in the header of all scripts.
	    Please, refer to the headers of all scripts in order to understand the class-hierarchy as
	    well as the properties and methods of the classes.
	    </p>
	    <p class="apb form"><a href="#mainIndex">Back To MainIndex</a></p>



	    </div>


	</div> <!-- end div workbench -->
</body>
</html>
